IDC_FINDEDIT		EQU 2
IDC_REPLACESTATIC	EQU 3
IDC_REPLACEEDIT		EQU 4
IDC_CHK_MATCHCASE	EQU 5
IDC_CHK_WHOLEWORD	EQU 6
IDC_RBN_UP			EQU 8
IDC_RBN_DOWN		EQU 9
IDC_BTN_FINDNEXT	EQU 11
IDC_BTN_REPLACE		EQU 12
IDC_BTN_REPLACEALL	EQU 13

.DATA?
FindBuffer			DB 256 DUP(?)
ReplaceBuffer		DB 256 DUP(?)

.DATA
frFlags				DWORD FR_DOWN	;i.e. Set the initial Find-Replace Direction to down.

.CODE

Find Proc Flags:DWORD
Local FindTextEx	:FINDTEXTEX
Local chrg			:CHARRANGE

	Invoke SendMessage,hEdit,EM_EXGETSEL,0,ADDR chrg
	
	MOV EAX,Flags
	TEST EAX,FR_DOWN
	.If !ZERO?
		;Down
		MOV EDX,chrg.cpMax
		MOV FindTextEx.chrg.cpMin,EDX
		MOV FindTextEx.chrg.cpMax,-1
	.Else
		;Up
		MOV FindTextEx.chrg.cpMax,0
		MOV ECX,chrg.cpMin
		MOV FindTextEx.chrg.cpMin,ECX
	.EndIf
	
	MOV FindTextEx.lpstrText,Offset FindBuffer
	
	Invoke SendMessage,hEdit,EM_FINDTEXTEX,Flags,ADDR FindTextEx
	.If EAX!=-1
		Invoke SendMessage,hEdit,EM_EXSETSEL,0,ADDR FindTextEx.chrgText
		XOR EAX,EAX
	.EndIf
	
	RET
	
Find EndP

Replace Proc hDlg:HWND
Local ft			:FINDTEXTEX

	Invoke SendMessage,hEdit,EM_EXGETSEL,0,ADDR ft.chrg
	
	;Let's see if search phrase is already selected!
	MOV ft.lpstrText,Offset FindBuffer		
	Invoke SendMessage,hEdit,EM_FINDTEXTEX,frFlags,ADDR ft
	MOV EDX,ft.chrgText.cpMin
	MOV ECX,ft.chrgText.cpMax
	
	;YES, it is!
	.If EDX==ft.chrg.cpMin && ECX==ft.chrg.cpMax
		Invoke SendMessage,hEdit,EM_REPLACESEL,TRUE,Offset ReplaceBuffer
	.EndIf
	
	;Let's find search phrase
	Invoke Find,frFlags
	
	RET 
Replace EndP

ReplaceAll Proc hDlg:HWND

	Invoke GetCursor
	PUSH EAX

	Invoke LoadCursor,0,IDC_WAIT
	Invoke SetCursor,EAX
	
	XOR EAX,EAX
	.While EAX!=-1
		Invoke Replace,hDlg
	.EndW
	
	POP EAX
	Invoke SetCursor,EAX

	RET
ReplaceAll EndP

FindReplaceDlgProc Proc hDlg:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
	MOV EAX,uMsg
	.If EAX==WM_INITDIALOG
		PUSH EBX
		MOV EBX,frFlags
		
		;Set check boxes
		TEST EBX,FR_MATCHCASE
		.If !ZERO?
			Invoke CheckDlgButton,hDlg,IDC_CHK_MATCHCASE,BST_CHECKED
		.EndIf
		
		TEST EBX,FR_WHOLEWORD
		.If !ZERO?
			Invoke CheckDlgButton,hDlg,IDC_CHK_WHOLEWORD,BST_CHECKED
		.EndIf
		
		;Set find direction
		TEST EBX,FR_DOWN
		.If !ZERO?
			MOV EAX,IDC_RBN_DOWN
		.Else
			MOV EAX,IDC_RBN_UP
		.EndIf
		
		Invoke CheckDlgButton,hDlg,EAX,BST_CHECKED
		POP EBX
		
		Invoke SetDlgItemText,hDlg,IDC_FINDEDIT,Offset FindBuffer
		Invoke SetDlgItemText,hDlg,IDC_REPLACEEDIT,Offset ReplaceBuffer
		
		.If lParam
			MOV EAX,BN_CLICKED
			SHL EAX,16
			OR EAX,IDC_BTN_REPLACE
			Invoke PostMessage,hDlg,WM_COMMAND,EAX,0
		.EndIf

	.ElseIf EAX==WM_COMMAND
		MOV EAX,wParam
		MOV EDX,EAX
		SHR EDX,16
		AND EAX,0FFFFh
		.If EDX==BN_CLICKED
			.If EAX==IDC_BTN_FINDNEXT
				Invoke Find,frFlags
				
			.ElseIf EAX==IDC_BTN_REPLACE
				Invoke GetDlgItem,hDlg,IDC_BTN_REPLACEALL
				PUSH EAX
				Invoke IsWindowEnabled,EAX
				POP ECX
				.If !EAX
					;Enable Replace all button
					Invoke EnableWindow,ECX,TRUE
					Invoke SetWindowText,hDlg,CTEXT("Replace")
					;Show replace
					Invoke GetDlgItem,hDlg,IDC_REPLACESTATIC
					Invoke ShowWindow,EAX,SW_SHOWNA
					Invoke GetDlgItem,hDlg,IDC_REPLACEEDIT
					Invoke ShowWindow,EAX,SW_SHOWNA
				.Else
					Invoke GetDlgItemText,hDlg,2,Offset FindBuffer,256
					Invoke GetDlgItemText,hDlg,4,Offset ReplaceBuffer,256
					Invoke Replace,hDlg
				.EndIf
				
			.ElseIf EAX==IDC_BTN_REPLACEALL
				Invoke ReplaceAll,hDlg
				
			.ElseIf EAX==IDC_RBN_DOWN
				;Set find direction to down
				OR frFlags,FR_DOWN
				
			.ElseIf EAX==IDC_RBN_UP
				;Set find direction to up
				AND frFlags,-1 XOR FR_DOWN
				
			.ElseIf EAX==IDC_CHK_MATCHCASE
				;Set match case mode
				Invoke IsDlgButtonChecked,hDlg,IDC_CHK_MATCHCASE
				.If EAX
					OR frFlags,FR_MATCHCASE
				.Else
					AND frFlags,-1 XOR FR_MATCHCASE
				.EndIf
				
			.ElseIf EAX==IDC_CHK_WHOLEWORD
				;Set whole word mode
				Invoke IsDlgButtonChecked,hDlg,IDC_CHK_WHOLEWORD
				.If EAX
					OR frFlags,FR_WHOLEWORD
				.Else
					AND frFlags,-1 XOR FR_WHOLEWORD
				.EndIf
				
			.Else;If EAX==14	;Cancel
				Invoke SendMessage,hDlg,WM_CLOSE,NULL,NULL
				
			.EndIf
		.ElseIf EDX==EN_CHANGE
			;Update text buffers
			.If EAX==IDC_REPLACEEDIT
				Invoke GetDlgItemText,hDlg,IDC_REPLACEEDIT,Offset ReplaceBuffer,256
			.ElseIf EAX==IDC_FINDEDIT
				Invoke GetDlgItemText,hDlg,IDC_FINDEDIT,Offset FindBuffer,256
			.EndIf
			
		.EndIf
		
	.ElseIf EAX==WM_CLOSE
		Invoke DestroyWindow,hDlg
		
	.ElseIf EAX==WM_ACTIVATE
		.If wParam==WA_ACTIVE || wParam==WA_CLICKACTIVE
			MOV EAX,hDlg
			MOV hModeless,EAX
		.ElseIf wParam==WA_INACTIVE
			MOV hModeless,0
		.EndIf
		
	.Else
		MOV EAX,FALSE
		RET
	.EndIf
	MOV  EAX,TRUE
	RET
FindReplaceDlgProc EndP
